Index: extensions/gsdl-video/trunk/perllib/plugins/VideoPlugin.pm
===================================================================
--- extensions/gsdl-video/trunk/perllib/plugins/VideoPlugin.pm	(revision 18543)
+++ extensions/gsdl-video/trunk/perllib/plugins/VideoPlugin.pm	(revision 18556)
@@ -703,135 +666,27 @@
     my ($pluginfo, $base_dir, $file, $block_hash, $metadata, $processor, $maxdocs, $total_count, $gli) = @_;
 
-    my $outhandle = $self->{'outhandle'};
-
-    # should we move this to read? What about secondary plugins?
-    print STDERR "<Processing n='$file' p='$self->{'plugin_type'}'>\n" if ($gli);
-    print $outhandle "$self->{'plugin_type'} processing $file\n"
-	    if $self->{'verbosity'} > 1;
-
-    my ($filename_full_path, $filename_no_path) = &util::get_full_filenames($base_dir, $file);
-
-    # create a new document
-    my $doc_obj = new doc ($filename_full_path, "indexed_doc", $self->{'file_rename_method'});
-
-
-    my $top_section = $doc_obj->get_top_section();
-
-    ### <Video Specific> ###
-    $doc_obj->set_OIDtype ($processor->{'OIDtype'}, $processor->{'OIDmetadata'});    
-    ### </Video Specific> ###
-
-
-    $doc_obj->add_utf8_metadata($top_section, "Plugin", "$self->{'plugin_type'}");
-    $doc_obj->add_utf8_metadata($top_section, "FileSize", (-s $filename_full_path));
- 
-    # sets the UTF8 filename (Source) for display and sets the url ref to URL encoded version
-    # of the UTF8 filename (SourceFile) for generated files
-    $self->set_Source_metadata($doc_obj, $filename_no_path);
-
-
-    # plugin specific stuff - what args do we need here??
-    unless (defined ($self->process($pluginfo, $base_dir, $file, $metadata, $doc_obj, $gli))) {
-	print STDERR "<ProcessingError n='$file'>\n" if ($gli);
-	return (-1,undef);
-    }
-    
-    # include any metadata passed in from previous plugins 
-    # note that this metadata is associated with the top level section
-    my $section = $doc_obj->get_top_section();
-    # can we merge these two methods??
-    $self->add_associated_files($doc_obj, $filename_full_path);
-    $self->extra_metadata ($doc_obj, $section, $metadata);
-    $self->auto_extract_metadata($doc_obj);
-
-    # if we haven't found any Title so far, assign one
-    # this was shifted to here from inside read()
-    $self->title_fallback($doc_obj,$section,$filename_no_path);
-    
-    $self->add_OID($doc_obj);
-
-
-    ### <Video Specific> ###
+    my ($rv,$doc_obj) = $self->SUPER::read_into_doc_obj(@_);
+
+    if ($rv != 1) {
+	return ($rv,$doc_obj);
+    }
+
 
     if (($self->{'enablestreaming'}) && ($self->{'extractkeyframes'})) {
+	my $section = $doc_obj->get_top_section();
 	my $oflash_filename = $self->{'oflash_filename'};
-	my $videoconvert = $self->{'videoconvert'};
 	my ($streamkeyframes_cmd,$ostreamkeyframes_filename) 
-	    = $videoconvert->streamkeyframes_cmd($oflash_filename,$doc_obj,$section);
+	    = $self->streamkeyframes_cmd($oflash_filename,$doc_obj,$section);
 
 	my $verbosity = $self->{'verbosity'};
 
-	my $streamkeyframes_options = { @{$videoconvert->{'flvtool2_monitor'}},
+	my $streamkeyframes_options = { @{$self->{'flvtool2_monitor'}},
 					'message_prefix' => "Stream Keyframes",
 					'message' => "Reprocessing video stream to add keyframes on timeline" }; 
-#### this used to be commented out!!!
-	$videoconvert->run_general_cmd($streamkeyframes_cmd,$streamkeyframes_options);
-    }
-    ### </Video Specific> ###
-    
-    return (1,$doc_obj);
-}
-
-sub add_dummy_text {
-    my $self = shift(@_);
-    my ($doc_obj, $section) = @_;
-
-    # add NoText metadata so we can hide this dummy text in format statements
-    $doc_obj->add_metadata($section, "NoText", "1");
-    $doc_obj->add_text($section, &gsprintf::lookup_string("{BasePlugin.dummy_text}",1));
-    
-}
-
-
-
-
-# do plugin specific processing of doc_obj
-sub process {
-    my $self = shift (@_);
-    # options??
-    my ($pluginfo, $base_dir, $file, $metadata, $doc_obj, $gli) = @_;
-
-    my $outhandle = $self->{'outhandle'};
-
-    my ($filename_full_path, $filename_no_path) = &util::get_full_filenames($base_dir, $file);
-
-
-    if ($self->{'ffmpeg_installed'}) {
-	my $utf8_filename_no_path = $self->filepath_to_utf8($filename_no_path);
-	my $url_encoded_filename = &util::rename_file($utf8_filename_no_path, $self->{'file_rename_method'});
-
-
-	#run convert to get the thumbnail and extract size and type info
-	my $result = $self->run_convert($base_dir, $filename_full_path, 
-					$url_encoded_filename, $doc_obj);
-	
-	if (!defined $result) {
-	    if ($gli) {
-		print STDERR "<ProcessingError n='$file'>\n";
-	    }
-	    print $outhandle "VideoPlugin: couldn't process \"$filename_full_path\"\n";
-	    return (-1,undef); # error during processing
-	}
-    } 
-    else {
-	if ($gli) {
-	    &gsprintf(STDERR, "<Warning p='VideoPlugin' r='{VideoConverter.noconversionavailable}: {VideoConverter.".$self->{'no_image_conversion_reason'}."}'>");
-	}
-	# all we do is add the original video file as an associated file, and set up srclink etc
-	my $assoc_file = $doc_obj->get_assocfile_from_sourcefile();
-	my $section = $doc_obj->get_top_section();
-
-	$doc_obj->associate_file($filename_full_path, $assoc_file, "", $section);
-
-	$doc_obj->add_metadata ($section, "srclink", "<a href=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[SourceFile]\">");
-	$doc_obj->add_metadata ($section, "/srclink", "</a>");
-	$doc_obj->add_metadata ($section, "srcicon", "<img src=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[SourceFile]\" width=\"100\">");
-
-    }
-    #we have no text - adds dummy text and NoText metadata
-    $self->add_dummy_text($doc_obj, $doc_obj->get_top_section());
-
-    return 1;
-
+
+	$self->run_general_cmd($streamkeyframes_cmd,$streamkeyframes_options);
+    }
+    
+    return ($rv,$doc_obj);
 }
 
@@ -908,16 +763,61 @@
 
 
-
-sub Doctype {
+sub StartDocument {$_[0]->{'PluginObj'}->xml_start_document(@_);}
+sub XMLDecl {$_[0]->{'PluginObj'}->xml_xmldecl(@_);}
+sub Entity {$_[0]->{'PluginObj'}->xml_entity(@_);}
+sub Doctype {$_[0]->{'PluginObj'}->xml_doctype(@_);}
+sub StartTag {$_[0]->{'PluginObj'}->xml_start_tag(@_);}
+sub EndTag {$_[0]->{'PluginObj'}->xml_end_tag(@_);}
+sub Text {$_[0]->{'PluginObj'}->xml_text(@_);}
+sub PI {$_[0]->{'PluginObj'}->xml_pi(@_);}
+sub EndDocument {$_[0]->{'PluginObj'}->xml_end_document(@_);}
+sub Default {$_[0]->{'PluginObj'}->xml_default(@_);}
+
+
+# This Char function overrides the one in XML::Parser::Stream to overcome a
+# problem where $expat->{Text} is treated as the return value, slowing
+# things down significantly in some cases.
+sub Char {
+    use bytes;  # Necessary to prevent encoding issues with XML::Parser 2.31+
+    $_[0]->{'Text'} .= $_[1];
+    return undef;
+}
+
+sub xml_start_document {
+    my $self = shift(@_);
     my ($expat, $name, $sysid, $pubid, $internal) = @_;
 
-    # my $root_tag = $self->{'root_tag'};
+}
+
+# Called for XML declarations
+sub xml_xmldecl {
+    my $self = shift(@_);
+    my ($expat, $version, $encoding, $standalone) = @_;
+}
+
+# Called for XML entities
+sub xml_entity {
+  my $self = shift(@_);
+  my ($expat, $name, $val, $sysid, $pubid, $ndata) = @_;
+}
+
+
+# Called for DOCTYPE declarations - use die to bail out if this doctype
+# is not meant for this plugin
+sub xml_doctype {
+    my $self = shift(@_);
+    my ($expat, $name, $sysid, $pubid, $internal) = @_;
+
+    # This test used to be done in xml_start_document
+    # Moved to here as seems more logical
 
     if ($name !~ "seg") {	
-	die "Root tag $name does not match expected <seg>";
-    }
-}
-
-sub StartTag {
+	die "VideoPlugin: Root tag $name does not match expected <seg>";
+    }
+}
+
+
+sub xml_start_tag {
+    my $self = shift(@_);
     my ($expat, $element) = @_;
 
@@ -931,5 +831,5 @@
 	#$self->{'flowplayer_thumblist'} = "thumbs: \\[";
 
-	my $output_dir = $self->{'videoconvert'}->{'cached_dir'};
+	my $output_dir = $self->{'cached_dir'};
 	my $cue_filename = &util::filename_cat($output_dir,"on_cue.xml");
 
@@ -945,6 +845,6 @@
 	my $avg_frame_num = int(($pre_frame_num+$post_frame_num)/2.0)+1;
 
-	my $output_dir = $self->{'videoconvert'}->{'cached_dir'};
-	my $ivideo_root = $self->{'videoconvert'}->{'file_root'};
+	my $output_dir = $self->{'cached_dir'};
+	my $ivideo_root = $self->{'cached_file_root'};
 
 	my $keyframe_index = $self->{'keyframe_index'};
@@ -1016,5 +916,6 @@
 }
 
-sub EndTag {
+sub xml_end_tag {
+    my $self = shift(@_);
     my ($expat, $element) = @_;
 
@@ -1032,15 +933,36 @@
 
 
-sub Text {
-    my $text = $_;
-}
-
-# This Char function overrides the one in XML::Parser::Stream to overcome a
-# problem where $expat->{Text} is treated as the return value, slowing
-# things down significantly in some cases.
-sub Char {
-  $_[0]->{'Text'} .= $_[1];
-  return undef;
-}
+
+
+
+# Called just before start or end tags with accumulated non-markup text in
+# the $_ variable.
+sub xml_text {
+    my $self = shift(@_);
+    my ($expat) = @_;
+}
+
+# Called for processing instructions. The $_ variable will contain a copy
+# of the pi.
+sub xml_pi {
+    my $self = shift(@_);
+    my ($expat, $target, $data) = @_;
+}
+
+# Called at the end of the XML document.
+sub xml_end_document {
+    my $self = shift(@_);
+    my ($expat) = @_;
+
+    $self->close_document();
+}
+
+
+# Called for any characters not handled by the above functions.
+sub xml_default {
+    my $self = shift(@_);
+    my ($expat, $text) = @_;
+}
+
 
 1;
